﻿-- Author      : Tabethial
-- Create Date : 8/23/2008 5:35:28 PM
-- Update Date : 4/14/2009 8:29:00 PM

enabled = 1;
leavetaxi = false;
ontaxi = false;
local debugon = false;
local VERSION = "4.0.0"
--buttonon = 1;

function Debug(msg)
	if debugon == true then
		DoMessage(msg)
	end		
end

function DoMessage(msg)
  DEFAULT_CHAT_FRAME:AddMessage("|cff00e000RandomPet "..VERSION..": |r"..msg)
end

function GetPet()	
	count = GetNumCompanions("CRITTER")
	petnum = math.random(count)
if enabled == 0 then
	DoMessage("RandomPet is turned off....\n\RandomPet on\nWill turn it back on");
else
if count == 0 then
	  DoMessage("You do not have any pets to summon");
	else
	if IsMounted() == 1 then
	  DoMessage("You are on a mount - your pet refuses to come out");
	 else
		CallCompanion("CRITTER",petnum)
	 end
end
end

	--creatureID, creatureName, spellID, icon, active = GetCompanionInfo("CRITTER",petnum)
	--SendChatMessage("decides to play with a pet and gets out "..creatureName,"EMOTE");
	--DoMessage("Number of Pets: "..count)
	--DoMessage("Pet Picked: "..petnum)
	--DEFAULT_CHAT_FRAME:AddMessage("|cff00e000RandomPet; Number of Pets: |r"..count)
	--DEFAULT_CHAT_FRAME:AddMessage("|cff00e000RandomPet; Pet Picked: |r"..petnum)
end

function OnUpdate(self,elapsed)
		if leavetaxi == true then
		Debug("leavetaxi = true")
		if not UnitOnTaxi("player") then
			Debug("player left taxi")
			leavetaxi = false
			ontaxi = false
			GetPet()
		end
	end

end

function Button1_OnClick()
	--DoMessage("Button Clicked")

	count = GetNumCompanions("CRITTER")
	mounts = GetNumCompanions("MOUNT")
	
	DoMessage("You have "..count.." pets!");
	DoMessage("You have "..mounts.." mounts!");
	GetPet()
end

function Rnd_Slash(msg)
	if msg == "buttonoff" then
		buttonon = 0;
		Frame1:Hide()
	else
		if msg == "buttonon" then
			buttonon = 1;
			Frame1:Show()
	else
	if msg == "get" then
	  Button1_OnClick();
else
	if msg == "on" then
		enabled = 1;
		DoMessage("RandomPet is active!");
	elseif
		msg == "off" then
		enabled = 0;
		DoMessage("RandomPet is NOT active!");
	else
  	DoMessage("RandomPet Usage: /randompet on  -- Turns on RandomPet");
  	DoMessage("RandomPet Usage: /randompet off -- Turns off RandomPet");
  	DoMessage("RandomPet Usage: /randompet get -- gets a pet");
  	DoMessage("RandomPet Usage: /randompet buttonon -- turns on display button");
  	DoMessage("RandomPet Usage: /randompet buttonoff -- turns off display button (this will cause Flight Path landing not to summon a pet)");
  	DoMessage("To call in a macro simply use /randompet get");
  end
end
end
end
end


function Frame1_OnLoad()

	Debug("OnLoad")
	Frame1:SetScript("OnEvent", eventHandler);  

	DoMessage(enabled)
	SLASH_RANDOMPET1 = "/randompet"
	SlashCmdList["RANDOMPET"] = Rnd_Slash;

	Debug("Registering Events")
	Frame1:RegisterEvent("ADDON_LOADED");
	Frame1:RegisterEvent("PLAYER_ENTERING_WORLD");   
  	Frame1:RegisterEvent("PLAYER_UNGHOST");
 	Frame1:RegisterEvent("PLAYER_ALIVE");
 	Frame1:RegisterEvent("PLAYER_CONTROL_GAINED");
  	Frame1:RegisterEvent("PLAYER_CONTROL_LOST");
	Frame1:RegisterEvent("UNIT_EXITING_VEHICLE");
	Frame1:RegisterEvent("PLAYER_LOSES_VEHICLE_DATA");

	DoMessage("Welcome to the "..VERSION.." version of RandomPet, click button to summon pet, drag button to proper placement.")
	DoMessage("Pets will auto summon in most cases.  If RandomPet is set to buttonoff it will most likely will not activate after a Flight Path ride.");

	DoMessage("")
	DoMessage("Type '/RandomPet help' to see the new features!")
  
  if buttonon == 0 then
  	Frame1:Hide()
  end
  -- For pet swaps at bank, swap up to X pets in inventory
  --this:RegisterEvent("BANKFRAME_OPENED");
end


function eventHandler(self, event, ...)		
   Debug(event);


	if (event == "PLAYER_CONTROL_LOST") then
		--Debug("PLAYER_CONTROL_LOST")
		if (UnitOnTaxi("player")) then
			Debug("Player on Taxi")
			ontaxi = true
		end
	end
	
	if (event == "PLAYER_CONTROL_GAINED") then
		if (UnitOnTaxi("player")) then
			Debug("Player on Taxi")
			ontaxi = true
		end			
			--Debug("PLAYER_CONTROL_GAINED")
			if (ontaxi) then
			  Debug("ontaxi = true, setting leavetaxi")
				leavetaxi = true
				ontaxi = false
			else
			Debug("player not on taxi, getting pet")	 
			GetPet()
			end
	end

    if (event == "ADDON_LOADED") then
    		if buttonon == nil then
   				buttonon = 1; -- This is the first time this addon is loaded; initialize the count to 1.
   			end	
   			
   		  if buttonon == 0 then
   		  	DoMessage("Hiding Button")
  				Frame1:Hide()
  			end
  
    end

	
	
if (event == "PLAYER_UNGHOST") then
	  --Debug("Event UNGHOST");
		GetPet()
	end

	if (event == "UNIT_EXITING_VEHICLE") then
	  --Debug("Event UNIT_EXITING_VEHICLE");
		GetPet()
	end

	if (event == "PLAYER_LOSES_VEHICLE_DATA") then
	  --Debug("Event PLAYER_LOSES_VEHICLE_DATA");
		GetPet()
	end

	if (event == "PLAYER_ENTERING_WORLD") then
	  --Debug("Event ENTERING_WORLD")
		GetPet()
	end

	if (event == "PLAYER_ALIVE") then
		--Debug("Event PLAYER_ALIVE")
		GetPet()
	end	
	
end
